/*
 *  build_test.c
 *  Copyright 2009 Dennis Schulmeister <dennis()ncc-1701a.homelinux.net>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 */

/* libc standard */
#include <string.h>

/* Non-standard library */
#include <caca0.h> /* libcaca-dev */

/* Our own includes */
#include "msg1.h"
#include "msg2.h"

int main(int argc, char** argv) {
    /* Set up a display to draw upon */
    if (caca_init()) {
        return 1;
    }

    /* Draw something */
    {
        int width  = caca_get_width();
        int height = caca_get_height();

        /* Background */
        caca_set_color(CACA_COLOR_GREEN, CACA_COLOR_GREEN);
        caca_clear();

        /* First message, now in a library */
        msg1();

        /* Second message, now in a library */
        msg2();

        /* Show it */
        caca_set_window_title(message1);
        caca_refresh();
    }

    /* Wait for ESC key */
    {
        int quit = 0;
        while (!quit) {
            int event;
            while ((event = caca_get_event(CACA_EVENT_KEY_PRESS))) {
                if ((event & 0xffff) == CACA_KEY_ESCAPE) {
                    quit = 1;
                }
            }
        }
    }

    /* Clean up */
    caca_end();
    return 0;
}
